%"Beyond Rank-1: Discovering Rich Community Structure in Multi-Aspect Graphs" 
function [X,Y,Xmat]=richcomm_getData(inputFile,outTenFile,d,nw,tenfile)
if tenfile==0
    strval=strcat('TensorFiles\',extractBetween(outTenFile,1,length(outTenFile)-4),'.mat');
    if exist(strval{1}, 'file') == 2 
        disp('File already exists, skipping creating new file')
        load(strval{1})
    else
        commRun=strcat('python createTensorFromGraph\createTensor.py -input'," ",inputFile,' -d '," ", num2str(d),' -output '," ",outTenFile,' -nw ', " ",num2str(nw));
        disp(commRun)
        r=system(commRun{1});
        clear d nw commRun ans r
        % Create tensor from file 
        T=load(strcat('TensorFiles\',outTenFile));
        maxVal=max(max(T));
        minVal=min(min(T));
        if minVal==0
            T(:,1:3)=T(:,1:3)+1;
        end
       
        X=sptensor(T(:,1:3),T(:,4),[maxVal maxVal maxVal]);
        A=importdata(strcat(inputFile),',');
        if min(min(A))==0
            A=A+1;
        end
        if maxVal==max(max(A))
            Xmat=sparse(A(:,1),A(:,2),ones(size(A,1),1),maxVal, maxVal);
        else
            Xmat=sparse(maxVal,maxVal);
            for i =1:maxVal
                Xmat=Xmat+double(X(:,:,i));
            end
        end
        strval=extractBetween(outTenFile,1,length(outTenFile)-4);
         Y=load(strcat('TensorFiles\',strval{1},'_labels.txt'));
                minVal=min(Y);
        if minVal(1)==0
            Y(:,1)=Y(:,1)+1;
        end
        if minVal(2)==0
            Y(:,2)=Y(:,2)+1;
        end
        
%         '''
%         orig=sparse(Xmat);
%         orig(max(size(orig)),max(size(orig))) = 0;
%         orig_sym = orig + orig';
%         [i,j,k] = find(orig_sym);
%         orig_sym(i(find(k==2)),j(find(k==2))) = 1;
%         Xmat = orig_sym - diag(diag(orig_sym));
%             
%         [S, indexComp] = graphconncomp(sparse(Xmat));
%         strval=extractBetween(outTenFile,1,length(outTenFile)-4);
%         Y=load(strcat('TensorFiles\',strval{1},'_labels.txt'));
%         minVal=min(Y);
%         if minVal(1)==0
%             Y(:,1)=Y(:,1)+1;
%         end
%         if minVal(2)==0
%             Y(:,2)=Y(:,2)+1;
%         end
%         idx=size(Y,1);
%         comm=max(Y(:,2));n=1;
%         for i=1:S
%             vcurind=find(indexComp(1,:)==i);
%             for j=1:size(vcurind,2)
%                 Y(idx+n,1)=vcurind(j);
%                 Y(idx+n,2)=comm+i;
%                 n=n+1;
%             end
%             
%             
%         end
 
        Y = sortrows(Y,2);
        disp('********* Saving tensor and communities ************');
        save(strcat('TensorFiles\',strval{1},'.mat'),'X','Y','Xmat');
        disp('********* Saving tensor and communities Done************')
    end
else
    
    strval=strcat('TensorFiles\',extractBetween(outTenFile,1,length(outTenFile)-4),'.mat');
    if exist(strval{1}, 'file') == 2 
        disp('File already exists, skipping creating new file')
        load(strval{1})
    
    else
    A=importdata(strcat(inputFile),',');
    if min(min(A))==0
            A=A+1;
    end
    X=sptensor(A(:,1:3),ones(size(A,1),1),[max(A(:,1)) max(A(:,1)) max(A(:,3))]);
    Xmat=sparse(max(A(:,1)),max(A(:,1)));
    for i =1:max(A(:,3))
           Xmat=Xmat+double(X(:,:,i));
    end
        Xmat(Xmat>0)=1;
        Xmat=Xmat-diag(diag(Xmat));
        [I,J]=find(Xmat==1);
        filenamenew=strcat(inputFile(1:end-4),'_1.txt');
        fidg = fopen( filenamenew, 'wt' );
        for i =1:size(I,1)
            gfn=strcat(num2str(I(i)),',',num2str(J(i)));
            fprintf( fidg, '%s\n', gfn);
        end
        fclose(fidg);
        commRun=strcat('python createTensorFromGraph\createTensor.py -input'," ",filenamenew,' -d '," ", num2str(d),' -output '," ",outTenFile,' -nw ', " ",num2str(nw));
        r=system(commRun{1});
        strval=extractBetween(outTenFile,1,length(outTenFile)-4);
        Y=load(strcat('TensorFiles\',strval{1},'_labels.txt'));
        minVal=min(Y);
        if minVal(1)==0
            Y(:,1)=Y(:,1)+1;
        end
        if minVal(2)==0
            Y(:,2)=Y(:,2)+1;
        end
           Y = sortrows(Y,2); 
        disp('********* Saving tensor and communities ************');
        save(strcat('TensorFiles\',strval{1},'.mat'),'X','Y','Xmat');
        disp('********* Saving tensor and communities Done************')
    end
end
        
end
